from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Stag_Parse_Pl_V0_1_0 = CommandToolBuilder(tool="stag_parse.pl", base_command=["stag-parse.pl"], inputs=[ToolInput(tag="in_parser_formatformat_one", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="|parser FORMAT\nFORMAT is one of xml, sxpr or itext, or the name of a perl module\nthis is the class that parsers the input file(s) and generates stag\nevents\nxml assumed as default")), ToolInput(tag="in_writer_formatformat_one", input_type=Boolean(optional=True), prefix="-w", doc=InputDocumentation(doc="|writer FORMAT\nFORMAT is one of xml, sxpr or itext, or the name of a perl module\nthis is the class that catches the events thrown by the parser; it\ncan be any class, but the class is typically a writer\nxml assumed as default")), ToolInput(tag="in_writer_use_defaults", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="|out FILE\nthe writer will use this file (defaults to STDOUT)")), ToolInput(tag="in_errf_filefile_store", input_type=File(optional=True), prefix="-e", doc=InputDocumentation(doc="|errf FILE\nfile to store parse error handler output")), ToolInput(tag="in_err_handler", input_type=String(optional=True), prefix="-errhandler", doc=InputDocumentation(doc="/MODULE\nFORMAT is one of xml, sxpr or itext, or the name of a perl module\nall parse error events go to this module")), ToolInput(tag="in_root_nodenameif_specified", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="|root NODE_NAME\nif this is specified, NODE_NAME becomes the root of the stag tree,\nand anything that was previously the root is placed below this.\nthis happens automatically if more than one file is parsed (because\nthere can only be one tree root)")), ToolInput(tag="in_color", input_type=Boolean(optional=True), prefix="-color", doc=InputDocumentation(doc="Works only if the output handler is able to provide ASCII-colors\n(currently supported for itext and xml)"))], outputs=[ToolOutput(tag="out_writer_use_defaults", output_type=File(optional=True), selector=InputSelector(input_to_select="in_writer_use_defaults", type_hint=File()), doc=OutputDocumentation(doc="|out FILE\nthe writer will use this file (defaults to STDOUT)")), ToolOutput(tag="out_errf_filefile_store", output_type=File(optional=True), selector=InputSelector(input_to_select="in_errf_filefile_store", type_hint=File()), doc=OutputDocumentation(doc="|errf FILE\nfile to store parse error handler output"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Stag_Parse_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

